#ifndef P2PSEM
#define P2PSEM
#define WIN32_LEAN_AND_MEAN
#ifndef _WIN32_WINNT
  #include <windows.h>
#endif

class P2pSem {
  public:
    P2pSem();
    ~P2pSem();
    void enterCritical();
    void exitCritical();
		int waitForGreenLight(int ms);
		void greenLight();
  protected:
    //CRITICAL_SECTION CriticalSection;//http://msdn.microsoft.com/en-us/library/ms682530(VS.85).aspx
		HANDLE sem;
		HANDLE hEvent;
    int mySemID;
    static int semCount;
};

#endif

