#ifndef CALLEEBACK_H_INCLUDED
#define CALLEEBACK_H_INCLUDED

struct gameInfo;
class CalleeBack{
  public:
    virtual ~CalleeBack(){}; //vc
    //~CalleeBack(){};
    virtual int receivedData(unsigned char *, int, struct gameInfo *gameInfo)=0;
    virtual void receivedPlayerReady(struct gameInfo *gameInfo)=0;
    virtual void receivedGo()=0;
    virtual void setNewDelay(int ms)=0;
		virtual void confirmMsg(struct gameInfo *gi)=0;
		virtual void deConfirmMsg(struct gameInfo *gi)=0;
		virtual void queueStateLoading(int syncLoaded, int syncLoading, int playerNo)=0;
		virtual void queueStateSaving(int syncNo, int playerNo)=0;
		virtual void confirmBounce(int playerNo, int originalFrame, int bounceFrame)=0;
		
		virtual void hold( int ms )=0;
		virtual struct gameInfo *getGI()=0;
  protected:
    CalleeBack(){};
};

#include "p2pSync.h"

#endif // CALLEEBACK_H_INCLUDED
